﻿	/************************************************************ 
	/ Auteurs : DELOISON Matthieu								/ 
	/ Fonction : classe du formulaire affiche les vignettes		/
	/															/
	************************************************************/


// on fait tous les import nescessaires
import com.delfiweb.utils.*;
import com.delfiweb.error.*;
import com.delfiweb.command.Delegate;
import com.delfiweb.command.AppelURLCommand;
import com.delfiweb.forms.*;


/**
* Construit le formulaire affiche les vignettes	
* 
* @class AffVignettes
* @author DELOISON Matthieu
* @version 0.1
*/
class AffVignettes extends Form
{	
	private var _main:MovieClip; 				// Pointeur sur le niveau	

	/*----- Variables globales -----------*/
	private var _niveau:Number;				// la profondeur des MovieClip
	private var _debut:Number;				// la profondeur des MovieClip
	private var _imgchargees:Boolean;				// la profondeur des MovieClip

	private var loadingQueue;
	private var loadingImg;
	private var _appel;
	private var _timeOut;
	private var _timeOut3;
	private var _to2;
	private var _to3;
	private var _numPhotoEnr:Number;

	
	/*----- Affiche les vignettes -----------*/
	private var _cadre:MovieClip;
	private var _zoom:MovieClip;
	private var _imageAg:MovieClip;
	private var fondCharge:MovieClip;
	
	
	/*--- Movie Clips du formulaire ---*/
	private var _titre:MovieClip;
	private var _voile:MovieClip;
	private var _fondIMG:MovieClip;


	/*--- les boutons ---*/
	private var _enregistrer:MovieClip;
	private var _precedent:MovieClip;
	private var _suivant:MovieClip;
	private var _retour:MovieClip;
	
	
	


	private var I1;
	
	
	
	/*--- Variables de formulaires ---*/
	
	
	/**
	* Constructeur privé, réalise la plupart des initialisations du programme, appelle ensuite
	* la méthode <b>_init</b> qui est la fonction de lancement autonome du programme, à utiliser
	* avec le PGameController
	* 
	* @method PMain 
	* @return Void
	*/
	private function AffVignettes ()
	{
		
		_main = this;
		_init();		
	}
	
	
	// fonction : initialise l'indispensable
	function _init()
	{
		_voile = _main.attachMovie ("voile", "voile", 3000);
			
		_niveau = 60;
		_debut = 0;
		onVisibleChange(true)
		construct();
		
	}
	
	
	// fonction : construction du formulaire
	function construct()
	{
		if(_root.couleurfond != undefined )
		{
			var dmccouleur = new Color(_fondIMG);
			dmccouleur.setRGB(_root.couleurfond);	
		}
		
		if(_root.couleurfondtitre != undefined )
		{
			var dmccouleur = new Color(_titre._titreIMG);
			dmccouleur.setRGB(_root.couleurfondtitre);	
		}
		
		/*--- les boutons ---*/
		//_enregistrer = _main.attachMovie("GBouton","enregistrer", 5013 ,{_x:400,_y:470, _txtBtn:_global.Strings[2], _position:"center", _colorTxt:_root.couleurTxtBtn, _colorBtn:_root.couleurBtn, _autosize:true, _visible:false})
		_precedent = _main.attachMovie("GBouton","precedent", 616 ,{_x:545,_y:470, _txtBtn:_global.Strings[1], _position:"center", _colorTxt:_root.couleurTxtBtn, _colorBtn:_root.couleurBtn, _autosize:true, _visible:false})
		_suivant = _main.attachMovie("GBouton","suivant", 619 ,{_x:675,_y:470, _txtBtn:_global.Strings[0], _position:"center", _colorTxt:_root.couleurTxtBtn, _colorBtn:_root.couleurBtn, _autosize:true, _visible:false})
		_suivant.onRelease = Delegate.create(this,_onBtnReleaseSuivant).getFunction();
		_precedent.onRelease = Delegate.create(this,_onBtnReleasePrecedent).getFunction();

		_retour = _main.attachMovie("GBouton","retour", 623 ,{_x:15,_y:470, _txtBtn:_global.Strings[3], _position:"center", _colorBtn:_root.couleurBtn, _colorTxt:_root.couleurTxtBtn, _autosize:true, _visible:true})
		_retour.onRelease = Delegate.create(this,_onBtnReleaseRetour).getFunction();
		
		
		_precedent._visible = _suivant._visible = false;

		generationVignette();
		
	}
	
	
	function generationVignette()
	{
		_main.attachMovie("chargementV","chargement",3010,{_x:30, _y:450})
		_main.chargement.contenu = _global.Strings[92];
		_main.chargement.barre._alpha = 80;
		_main.chargement.fondCharge._visible = false;
		
		
		_cadre = _main.createEmptyMovieClip("cadre", _niveau++);
		_imgchargees = false;
		
		_retour._visible = false;
		
		loadingQueue = new LoadStack ();
		
		var coordX:Number = 10;
		var coordY:Number = 60;
	
		if(_root.couleurtitre != undefined)
			_titre.contenu = "<font color=\""+_root.couleurtitre+"\">"+Constant.NOMREPCHOISI+"</font>";
		else
			_titre.contenu = Constant.NOMREPCHOISI;
			
		var idTAb:Number = 0;
		var debutIMG:Number = 0;
		var calcul:Number = 0;
		
		for(var i1=0; i1 < Constant.DETAILSIMAGES.length; i1++)
		{
			
			if( calcul%6 == 0 && calcul!=0)
			{
				coordY += 130;
				coordX = 10;
			}
			
			if (Constant.DETAILSIMAGES[idTAb].vignette != undefined && Constant.DETAILSIMAGES[idTAb].urlimage != undefined && Constant.DETAILSIMAGES[idTAb].nomrepertoire == Constant.NOMREPCHOISI)
			{
				if(debutIMG >= _debut)
				{
					_cadre.attachMovie("cartemini","vignette"+i1,_niveau++,{_x:coordX, _y:coordY, _width:120, _height:120})
					_cadre["vignette"+i1].createEmptyMovieClip("image"+i1, _niveau++);
					// à ne faire qu'une fois booléen, idem onLoadComplete
					
					_cadre["vignette"+i1]["image"+i1]._x = Constant.DECALAGE;
					_cadre["vignette"+i1]["image"+i1]._y = Constant.DECALAGE;
					
					loadingQueue.loadClip (Constant.DETAILSIMAGES[idTAb].vignette, _cadre["vignette"+i1]["image"+i1]);
					
					_cadre["vignette"+i1]["image"+i1]._visible = false;
					_cadre["vignette"+i1]["image"+i1]._alpha = 0;
					coordX += 130;
					
					Constant.NBVIGNETTESTROUVEES = i1+1;
					calcul++;
				}

				debutIMG++;
	
			}
			idTAb++;	

			if(calcul >= Constant.NBVIGNETTES )
			{
				Constant.NBVIGNETTESTROUVEES = i1+1;
				i1 = Constant.DETAILSIMAGES.length;
			}
				
		}
		
		
		_cadre["vignette"+i1]["image"+i1]._visible = false;
		_cadre["vignette"+i1]["image"+i1]._alpha = 0;
			
		if(Constant.NBVIGNETTESTROUVEES == undefined) Constant.NBVIGNETTESTROUVEES = Constant.NBVIGNETTES;
		
		loadingQueue.addListener (this);
		loadingQueue.startLoad ();
		
	}
	
	
	/*--------------------------------------------------------------------------*/
	/*-------------------- Chargement des photos -------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	
	function onLoadStart ()
	{
		if(_main.chargementIMGA)
		{
			_imageAg._visible = false;
		}
		
		if(_main.chargement)
		{
			onVisibleChange(false)
			_main.chargementIMG.removeMovieClip();
		}
		
		
		
	}
	
	
	function onLoadProgress()
	{
		
		if(_main.chargementIMGA)
		{// agrandissement d'une vignette
			var temp2:Number = loadingImg.currentRate;
			if (temp2 <= 0) temp2 = 0;
			
			_main.chargementIMGA.barre.percentOn(temp2);
		}
		
		if(_main.chargement)
		{// chargement des vignettes
			var temp:Number = loadingQueue.currentRate;
			if (temp <= 0) temp = 0;
			_main.chargement.barre.percentOn(temp);
			_timeOut = new Delegate(this,_buildImg);
			_to2 = new AppelFct (_timeOut,200);// en ms
			
		}
		
	}
	
	
	function onLoadComplete()
	{

		_main.chargement.removeMovieClip();			
		_timeOut = new Delegate(this,_arretImg);
		_to2 = new AppelFct (_timeOut,500);// en ms

	}
	
	
	function onLoadError()
	{
		//("erreur de chargement")
	}
	
	
	function _arretImg()
	{
		_buildImg();
		affectBtn(); // en plus du timeOut
		_imgchargees = true;
	}
	
	
	function _buildImg()
	{
		if(!_imgchargees)
		{
				
			var idTAb:Number = 0;
			var debutIMG:Number = 0;
			for(var i1=0; i1 < Constant.DETAILSIMAGES.length; i1++)
			{
				
				if(_cadre["vignette"+i1]["image"+i1]._width > 1)
				{
					_cadre["vignette"+i1]["image"+i1]._width = Constant.WIDTHVIGNETTE;
					_cadre["vignette"+i1]["image"+i1]._height = Constant.HEIGTHVIGNETTE;
					
					
					for(var i10=0; i10 < Constant.DETAILSIMAGES.length; i10++)
					{
						
						if (Constant.DETAILSIMAGES[idTAb].urlimage != undefined && Constant.DETAILSIMAGES[idTAb].nomrepertoire == Constant.NOMREPCHOISI)
						{
							
							if(debutIMG >= _debut)
							{
								_cadre["vignette"+i1].onRollOver = Delegate.create(this,_onBtnRollOver, i1, idTAb).getFunction();
								_cadre["vignette"+i1].onRollOut = Delegate.create(this,_onBtnRollOut, i1, idTAb).getFunction();
								_cadre["vignette"+i1].onRelease = Delegate.create(this,_onBtnReleaseZoomIn, idTAb).getFunction();
								
								i10 = Constant.DETAILSIMAGES.length;
								
							}
							debutIMG++;
							idTAb++;
							
						}
						else idTAb++;
					}
					if( _cadre["vignette"+i1]["image"+i1]._alpha == 0 ) _cadre["vignette"+i1]["image"+i1]._alpha = 50;
					
					_cadre["vignette"+i1]["image"+i1]._visible = true;
					
				}
				
			}
		}
		else
		{
			//_appel.stop();		
			
		}
	}

	
	
	function affectBtn()
	{
		_retour._visible = true;
		var nbimages:Number = 0;
		for(var i1=0; i1 < Constant.DETAILSIMAGES.length; i1++)
		{
			
			if (Constant.DETAILSIMAGES[i1].urlimage != undefined && Constant.DETAILSIMAGES[i1].nomrepertoire == Constant.NOMREPCHOISI)
			{
				nbimages++;
			}	
			
		}

		if(nbimages < _debut) _suivant._visible = false;
		
		if( nbimages > (_debut+Constant.NBVIGNETTES) )	_suivant._visible = true;
		
		if( _debut==0 ) _precedent._visible = false;
		
		if( _debut>0 ) _precedent._visible = true;
		
	}
	
	/*--------------------------------------------------------------------------*/
	/*------------------- Action sur les boutons -------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	function _onBtnReleasePrecedent()
	{
		_debut -= Constant.NBVIGNETTES;
		_precedent._visible = false;
		_cadre.removeMovieClip();
		generationVignette();
	}
	
	
	function _onBtnReleaseSuivant()
	{
		_debut += Constant.NBVIGNETTES;
		_suivant._visible = false;
		_cadre.removeMovieClip();
		generationVignette();
	}
	

	
	function _onBtnReleaseEnregistrer(index:Array)
	{
		var num:Number = index[0];
		if ( num == undefined ) num = _numPhotoEnr;
		// redirection sur le site
		var obj:Object=""; 
		//var command = new AppelURLCommand (Constant.DETAILSIMAGES[num].urlimage,"_blank", "GET", {}).execute();
		
		// Mise en forme du nom de l'image
		var nomImage:String = new ReplaceString (Constant.DETAILSIMAGES[num].nomimage).arrayReplace ([" "], ["-"] );
		var tempUlrimage:String = Constant.DETAILSIMAGES[num].urlimage;
		var Arraytemp:Array = tempUlrimage.split(".");
		nomImage += "."+Arraytemp[Arraytemp.length-1];		
		
		var command = new AppelURLCommand (_root.nomFicPHP,"_blank", "POST", {image:Constant.DETAILSIMAGES[num].urlimage,nomimage:nomImage}).execute();
		command.execute ();
	}
	
	
	
	function _onBtnReleaseRetour()
	{
		previous(); // formulaire précédent
	}
	
	
	
	/*----------------------------------------------------------*/
	/*------------- Effets sur les images ----------------------*/
	/*----------------------------------------------------------*/
	
	
	function _onBtnRollOver(index:Array)
	{
		var num:Number = index[0];
		var idTAb:Number = index[1];
		_cadre["vignette"+num]["image"+num]._alpha = 80;
		PMain.instance.onOver (Constant.DETAILSIMAGES[idTAb].nomimage, _cadre["vignette"+num]);
	}
	
	
	
	function _onBtnRollOut (index:Array)
	{
		var num:Number = index[0];
		_cadre["vignette"+num]["image"+num]._alpha = 50;
		PMain.instance.onOut ();
	}
	
	
	
	// fonction : il a clické sur une vignette
	function _onBtnReleaseZoomIn(index:Array)
	{
		//onVisibleChange (true);
		_main.attachMovie("chargementV","chargementIMGA",8000,{_x:Constant.XCHARGEMENT, _y:Constant.YCHARGEMENT})
		_main.chargementIMGA.contenu = _global.Strings[91];
		//_main.chargementIMGA._alpha = 90;
		
		var num:Number = index[0];

		_zoom = _main.attachMovie("carte","zoom",4000,{_x:5, _y:-8, _width:770, _height:500, _visible:false})
		_zoom.onRelease = Delegate.create(this,_onBtnReleaseZoomOut, num).getFunction();
		
		_imageAg = _main.createEmptyMovieClip("imageAg", 4005);
		loadingImg = new LoadStack ();
		loadingImg.loadClip (Constant.DETAILSIMAGES[num].urlimage, _imageAg);
		loadingImg.addListener (this);
		_imageAg._alpha = 0;

		loadingImg.startLoad ();
		loadingImg.onLoadComplete = Delegate.create(this,_onLoadComplete).getFunction();

		//_enregistrer._visible = true;
		_numPhotoEnr = num;
		persoMenuEnregistrer(num)
		//_enregistrer.onRelease = Delegate.create(this,_onBtnReleaseEnregistrer,num).getFunction();

		onVisibleChange(true);
		
	}
	
	
	
	// entrée : le numéro de la photo
	// fonction : personnalisation du menu flash
	function persoMenuEnregistrer(num:Number)
	{
		//("persoMenuEnregistrer")
		Stage.showMenu = true;
		var menuPerso:ContextMenu = new ContextMenu()

		menuPerso.hideBuiltInItems(); // cacher le menu d'origine
		
		var m1:ContextMenuItem = new ContextMenuItem("Auteur Galerie Photo", Delegate.create(this,_mail).getFunction())
		
		var m2:ContextMenuItem = new ContextMenuItem(_global.Strings[2]+"...", Delegate.create(this,_onBtnReleaseEnregistrer,num).getFunction())
		m2.separatorBefore = true;// insérer une séparation

		menuPerso.customItems = [m1,m2];
		_root.menu = menuPerso; // mettre à jour le menu
	}
	
	
	
	// entrée : le numéro de la photo
	// fonction : personnalisation du menu flash
	function persoMenu(num:Number)
	{
		//("persoMenu")
		Stage.showMenu = true;
		var menuPerso:ContextMenu = new ContextMenu()

		menuPerso.hideBuiltInItems(); // cacher le menu d'origine
		
		var m1:ContextMenuItem = new ContextMenuItem("Auteur Galerie Photo", Delegate.create(this,_mail).getFunction())
		//m2.separatorBefore = true;// insérer une séparation
		
		menuPerso.customItems = [m1];
		//menuPerso.customItems = [m1,m2];
		_root.menu = menuPerso; // mettre à jour le menu
	}
	
	
	function _mail()
	{
		PMain.instance._mail();
	}
	
	
	function _onLoadComplete()
	{
		_timeOut3 = new Delegate(this,_buildPhoto);
		_to3 = new AppelFct (_timeOut3,500);// en ms
	}
	
	
	function _onBtnReleaseZoomOut(index:Array)
	{
		
		var fin = new mx.transitions.Tween (_zoom, "_alpha" , mx.transitions.easing.Regular.easeIn, 100, 0, Constant.DUREESCALE, true )
		new mx.transitions.Tween (_imageAg, "_alpha" , mx.transitions.easing.Regular.easeIn, 100, 0, Constant.DUREESCALE, true )
		fin.onMotionFinished = Delegate.create(this,_onClearAgrandissement).getFunction();
		
		persoMenu();
		//_enregistrer._visible = false;
	}
	
	
	function _buildPhoto()
	{
		_main.chargementIMGA.removeMovieClip();
		onVisibleChange(true);
		
		_imageAg._xscale=20;
		_imageAg._yscale=20;
		
		for(var cpt1=0; cpt1<52; cpt1++)
		{
			if( _imageAg._width < (_zoom._width-20) && _imageAg._height < (_zoom._height-55) )
			{
				_imageAg._xscale += 4;
				_imageAg._yscale += 4;
			}
			else
				cpt1 = 53;
		}
		
		
		_imageAg._xscale -= 2;
		_imageAg._yscale -= 2;
		
		var zoomImageWidth:Number = _imageAg._width;
		var zoomImageHeight:Number = _imageAg._height;
		
		// position de la photo
		_imageAg._x = (_zoom._width - _imageAg._width)/2 + _zoom._x;
		_imageAg._y = (_zoom._height - _imageAg._height)/2 + _zoom._y;
		
		// taille et position du cadre de la photo
		_zoom._xscale = 100;
		_zoom._yscale = 100;
		var widthMax:Number = zoomImageWidth + 25;
		var heightMax:Number = zoomImageHeight + 25;
		_zoom._x = _imageAg._x - 10;
		_zoom._y = _imageAg._y - 10;
		
		// lancement des effets
		_imageAg._alpha = 100;
		_imageAg._visible = true;
		_zoom._visible = true;
		new mx.transitions.Tween (_zoom, "_width" , mx.transitions.easing.Regular.easeIn, 10, widthMax, Constant.DUREESCALE, true )
		new mx.transitions.Tween (_zoom, "_height" , mx.transitions.easing.Regular.easeIn, 10, heightMax, Constant.DUREESCALE, true )
		new mx.transitions.Tween (_imageAg, "_width" , mx.transitions.easing.Regular.easeIn, 0, zoomImageWidth, Constant.DUREESCALE, true )
		new mx.transitions.Tween (_imageAg, "_height" , mx.transitions.easing.Regular.easeIn, 0, zoomImageHeight, Constant.DUREESCALE, true )
	}
	
	
	/*--------------------------------------------------------------------------*/
	/*---------------------------- Divers --------------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	function _onClearAgrandissement()
	{
		_zoom.removeMovieClip();
		_imageAg.removeMovieClip();
		onVisibleChange (false);
	}
	
	

	// fonction : permet de masquer le voile en fonction de la PDiag
	function onVisibleChange (b)
	{
		_voile._visible = b;
		if (b)
		{
			_voile.useHandCursor = false;
			_voile.onRelease = function ()
			{
			};
		} 
		else
		{
			_voile.useHandCursor = false;
			delete _voile.onRelease
		}
		
	}
	
	

}


		
		