﻿	/************************************************************ 
	/ Auteurs : DELOISON Matthieu								/ 
	/ Fonction : Galerie Photo									/
	/															/
	/ Date de création : 21/11/2005  							/
	/ Date de mise à jour : 02/12/2005  						/ 
	************************************************************/


/* NOTES :

 
*/

import com.delfiweb.utils.*;
import com.delfiweb.error.*;
import com.delfiweb.forms.*;
import com.delfiweb.command.Delegate;
import com.delfiweb.command.AppelURLCommand;

// les effets
//import mx.transitions.TransitionManager;
//import mx.transitions.*;
//import mx.transitions.Wipe;
//import mx.transitions.easing.*;

/**
* Point d'entrée du programme, Compatible MTASC (MotionTwin ActionScript 2 Compiler)
* 
* @class PMain
* @author Claude François
* @version 0.1
*/
class PMain
{
	/*----------- Composants envoyé par le flash ------------*/
	
	
	/*----------- Composants de la scène ------------*/
	private static var _instance:PMain; 		// L'instance unique du singleton
	public var isLocal:Boolean; 				// Est-t'on en local ?
	public var isDebug:Boolean; 				// Active-t'on le debug ?
	private var _main:MovieClip; 				// Pointeur sur le niveau	
	private var _voile:MovieClip;				// Voile d'opacité
				
		
	/*----- Constantes Movie Clip------*/
	private var _fond:MovieClip;
	
	
	/*----- Gestion du fichier xml -----------*/
	public var _parser;
	private var XMLconfig:XML;					// le xml des modes de paiement
	
	
	/*----- Constantes ------*/
	private var active:Boolean;				// pour le tooltip
	private var _niveau:Number;					// la profondeur des movies clips		
	private var _niveauSup:Number;					// la profondeur des movies clips	
	
	
	/*----- Les formulaires -----------*/
	private var struct:FormStruct;
	private var gestionDossiers:FormStep;
	private var affVignettes:FormStep;


	/*----- Constantes des formulaires ------*/

	
	
	/**
	* Constructeur privé, réalise la plupart des initialisations du programme, appelle ensuite
	* la méthode <b>_init</b> qui est la fonction de lancement autonome du programme, à utiliser
	* avec le PGameController
	* 
	* @method PMain 
	* @return Void
	*/
	private function PMain ()
	{
		// si le parametre version n'est pas transmis on est en local
		isLocal = (_root.version == undefined) ? true : false;		
		// si on est en local le debug est donc activé, sinon c'est en fonction du parametre php
		isDebug = (isLocal) ? true : ((_root.debug != undefined) ? true : false); 
		
		// on s'inscrit comme écouteur du diffuseur d'erreur
		ErrorDispatcher.addListener(this);
		
		// on stocke un pointeur sur le niveau
		_main = _root;


		isLocal = false;
		isDebug = false;
		
		// si on est en local on définit les variables qui nous sont nécessaires
		if(isLocal)
		{
			// si on est en local on diffuse toutes les erreurs possible
			//ErrorDispatcher.FILTER = 5;
			//trace("mode local")
			_root.urlXML = "images.xml";
			_root.chaine1 = "chargement en cours";
			_root.couleurfond = "0x89B261";
			_root.couleurfondtitre = "0x3B6F0B";
			_root.couleurtitre = "#00ff66";
			_root.couleurBtn = "0x3B6F0B"
			_root.couleurTxtBtn = "89B261"
			//isLocal = false;
			
		}
		//else	_root.urlXML = "swf/paiement-unique.xml";
		if(_root.couleurBtn == undefined) 	_root.couleurBtn = "0x999999";
		if(_root.couleurTxtBtn == undefined) _root.couleurTxtBtn = "ffffff";
	}
	
	/**
	* C'est le point d'entrée du programme, appelé sur la première image du fla,
	* elle est compatible MTASC
	* 
	* @usage	PMain.main()
	* @method 	static main
	* @return 	Void
	*/
	public static function main ()
	{
		if(_instance == undefined)
		{
			_instance = new PMain();
			_instance._init();
		}
	}
	
	
	/**
	* C'est la qu'on fera le vrai setup du programme, prévue pour une utilisation avec 
	* le nouveau Debugger
	* 
	* @usage 	PMain.instance._init()
	* @method 	_init
	* @return 	Void
	*/
	public function _init()
	{
		_niveau = 10; 
		_niveauSup = 5000;
		if (!_voile)
		{
			_voile = _main.attachMovie ("voile", "voile", 3000);
			
			_fond = _main.createEmptyMovieClip("image", _niveau++);
			_fond.attachMovie("fondscene","fond",_niveau++, {_x:-5, _y:-5})
			_parser = Parser.getInstance();
			_main.attachMovie("tooltip","tooltip",6005,{_x:-200});// alt sur les vignettes
		
		}
		active = true;
		_main.attachMovie("chargement","chargementIMG",8000,{_x:Constant.XCHARGEMENT, _y:Constant.YCHARGEMENT})
		_main.chargementIMG.contenu = _root.chaine1;
		_main.chargementIMGA._alpha = 90;
		/*APCore.initialize();
		_myListener = new Object();
		APCore.addListener(_myListener);
		*/
		
		
		onVisibleChange(true)
		jouer ();
		//_root.soleil.swapDepths(15000)
	}
		
	/**
	 *	Cette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function jouer ()
	{
		DecodeXML();
		//construct(); // est appelé par parseXML
		
	}
	
	
	
	/**
	 *	Cette fonction lance tout d'abord la vérification
	 *  de doublon flash
	 * 
	 *	@usage		PMain.instance.jouer()
	 *	@method		jouer
	 *	@return		Void
	 */
	public function rejouer()
	{
		jouer();
	}
	
			
	/**
	* @property instance (PMain) L'instance unique de la classe PMain (read-only)
	*/
	public static function get instance ():PMain
	{
		return _instance;
	}
	
	
	/** 
     * Récupère les évènements de l'ErrorDispatcher afin de les diffusés et de gérer les 
     * exceptions du programme. 
     *  
     * @method onError 
     * @param e (Error)           
	 * @return Un objet Error 
     */ 
     public function onError(e:DError) 
     { 
         //if (isDebug) trace ("Erreur:" + e);

		switch(e.msg)
		{ 
			  
			/*case "1": // "plus de parties": 

					break;
						
			case "bloqué":
//					break;
					
				*/	
			default: 
					//trace("onError : "+e)
                    break; 
		} 
		   
	}
	
	
	/*--------------------------------------------------------------------------*/
	/*------------------- Gestion de la gallerie -------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	
	// fonction : construire le tableau des menus
	function DecodeXML():Void
	{
		/*--- Décode le fichier XML ---*/
		XMLconfig = new XML();
		XMLconfig.ignoreWhite = true;
		XMLconfig.onLoad = function()
		{
			PMain.instance._parser.parseXML (PMain.instance.XMLconfig)
		}
		if(isLocal) XMLconfig.load("images.xml");
		else XMLconfig.load(_root.urlXML+"?killcache="+Math.floor(Math.random()*100));
	}
	
	
	
	// fonction : construction du décor
	function construct()
	{
		persoMenu();
		copyright();
		construcFormulaires();
	}
	
	
	
	
	// fonction : construit et gère les formulaires
	function construcFormulaires()
	{
		gestionDossiers = new FormStep("affDossiers",1); // étape suivante
		affVignettes = new FormStep("affVign",2,0);// étape suivante, étape précédente

		
		/* * N° étapes :
		* 
		* 0 -> affiche les dossiers photos disponibles
		* 1 -> affiche les vignettes du dossier sélectionné
		* 
		* */
		
		struct = new FormStruct([gestionDossiers,affVignettes], _fond);

		_main.chargementIMG.removeMovieClip();
		onVisibleChange(false);
		struct.buildForm();
				
		// définit la fonction de validation
		struct.onSubmit = function (state, obj)
		{
			if (PMain.instance.isDebug) 
			for(var i in obj)
			{
				//trace("dans onSubmit : "+i+" : "+obj[i]);
			}
			
		}
		
		// définit la fonction de vérification
		struct.onSubmitVerify = function (objet)
		{			
			//if (PMain.instance.isDebug) 
			for(var i in objet)
			{
				//trace("dans onSubmitVerify : "+i+" : "+objet[i]);
			}

			switch (objet.numForm)
			{
				case 2 :	// 
						try
						{

						}
						catch (e:FormError)
						{
							e.callBehaviour();
							return false;
						}
						break;
				
				case 5 : // 
						try
						{

						}
						catch (e:FormError)
						{
							e.callBehaviour();
							return false;
						}
						break;
				
				case 6 : // cas d'erreur
	
						break;
				default :	throw new DError ("erreur formulaire","onSubmitVerify",1);	
							break;
				
			}
			
			
			
			return true;
		}
	}
	
	
	
	/*----------------------------------------------------------*/
	/*------------- Actions sur les boutons --------------------*/
	/*----------------------------------------------------------*/
	
		
	function copyright()
	{
		
		_main.attachMovie("auteur","auteur", 3033 ,{_x:310,_y:485, _alpha:70})
		_main.attachMovie("auteurOver","auteurOver", 3043 ,{_x:310,_y:485, _visible:false})

		_main.auteur._alpha = 80;
		_main.auteurOver.onRelease = Delegate.create(this,_onBtnReleaseAuteur).getFunction();
		_main.auteur.onRollOver = Delegate.create(this,_onBtnReleaseAuteurRollOver).getFunction();
		_main.auteurOver.onRollOut = Delegate.create(this,_onBtnReleaseAuteurRollOut).getFunction();
		
	}
	
	
	
	function _onBtnReleaseAuteur()
	{
		// redirection sur le site
		var obj:Object=""; 
		var command = new AppelURLCommand ("http://matthieu.deloison.free.fr","_blank", "GET", {}).execute();
		command.execute ();
	}
	
	
	function _onBtnReleaseAuteurRollOver()
	{
		_main.auteurOver._visible = true;
	}
	
	
	function _onBtnReleaseAuteurRollOut()
	{
		_main.auteurOver._visible = false;
	}
	
	
	/*----------------------------------------------------------*/
	/*------------- Alt sur les photos -------------------------*/
	/*----------------------------------------------------------*/
	
	function onOver (str, clip)
	{
		if (active)
		{
			_main.tooltip._visible = true;
			_main.tooltip.stip = str;
			_main.tooltip._y = clip._y - _main.tooltip._height + clip._parent._y + 8;
			_main.tooltip._x = clip._x + clip._parent._x + clip._width / 2;
			_main.tooltip.fl._y = _main.tooltip.tip._height;
			
			
			/* test la taille du tooltip et de la scène */
			_main.tooltip.tip._x =  -_main.tooltip.tip._width/2;
			
			
			// le bon système

			// repositionnement de la bulle à droite
			if( (_x + _main.tooltip._x + _main.tooltip._width ) > (_fond._x + _fond._width+40) )
			{
				_main.tooltip._x -= (_x + _main.tooltip._x + _main.tooltip._width/2 ) - (_fond._x + _fond._width)+20;
				//_main.tooltip._x += 80;
				//trace("> : "+_x)
			}
			
			// repositionnement de la bulle à gauche
			//trace("x: "+temp)
			
			if((_main.tooltip._x-_main.tooltip._width/2) < _x) _main.tooltip._x = _x+_main.tooltip._width/2;

			
		}
		_main.tooltip.tip.autoSize = "center";
		active = true;
	}
	
	
	function onOut ()
	{
		if (active)
		{
			_main.tooltip._visible = false;
		}
		_main.tooltip.tip.autoSize = "center";
		active = true;
	}
	

	/*----------------------------------------------------------*/
	/*------------- Divers -------------------------------------*/
	/*----------------------------------------------------------*/
	
		
	// fonction : personnalisation du menu flash
	function persoMenu()
	{
		Stage.showMenu = true;
		var menuPerso:ContextMenu = new ContextMenu()

		menuPerso.hideBuiltInItems(); // cacher le menu d'origine
		
		var m1:ContextMenuItem = new ContextMenuItem("Auteur Galerie Photo", Delegate.create(PMain.instance,_mail).getFunction())
		//var m2:ContextMenuItem = new ContextMenuItem("Book", function(){})
		
		//m2.separatorBefore = true;// insérer une séparation
		
		menuPerso.customItems = [m1];
		//menuPerso.customItems = [m1,m2];
		_root.menu = menuPerso; // mettre à jour le menu
	}
	
	
	// fonction : personnalisation du menu flash - contact me
	function _mail() 
	{
		new AppelURLCommand ("http://matthieu.deloison.free.fr","_blank", "GET", {nocache:random(100)}).execute();		
	}
	

	// fonction : permet de masquer le voile en fonction de la PDiag
	function onVisibleChange (b)
	{
		_voile._visible = b;
		if (b)
		{
			_voile.useHandCursor = false;
			_voile.onRelease = function ()
			{
			};
		} 
		else
		{
			_voile.useHandCursor = false;
			delete _voile.onRelease
		}
		
	}
		
	
}// fin de la classe