﻿import com.delfiweb.forms.*

/**
 *	La classe form step permet de déterminer une étape dans un formulaire
 * 	multipage. On précise l'identifiant de liaison du formulaire et les étapes
 * 	qui l'entourent. Un objet <i>FormStep</i> ne sert concrètement qu'au model
 * 	du formulaire, elle ne sont pas utilisées par l'utilisateur.
 * 
 *	@author		Cedric Néhémie
 *	@version	0.1
 *	@class		FormStep
 */
class com.delfiweb.forms.FormStep 
{
	public var linkageId:String;		// liens du clip formulaire à créer
	public var previousId:Number;		// id du formulaire précédent
	public var nextId:Number;			// id du formulaire suivant
	
	
	/**
	 *	Constructeur d'une étape, on lui transmet toutes les infos dont l'étape
	 * 	a besoin pour se situer dans la structure du formulaire.
	 * 	Le <i>lid</i> dans ce cas doit être rattachée a une classe étendant <i>Form</i>
	 * 	afin de se plugger correctement dans le <i>FormStruct</i>.
	 * 
	 * 	@method FormStep
	 * 	entrée :	lid	String Identifiant de liaison du formulaire
	 * 	entrée :	nid	Number Index de l'étape suivante
	 * 	entrée :	pid	Number Index de l'étape précédente
	 *	utilisation :	var step = new FormStep ("myForm",0,2);
	 *	sortie :	Void
	 */
	public function FormStep (lid:String,nid:Number,pid:Number)
	{
		linkageId = lid;
		previousId = pid;
		nextId = nid;
	}
}